import { Either } from 'fp-ts/lib/Either';
import * as tsm from 'ts-morph';
import ts from 'typescript';
import { Exception } from '../utils';
interface TypeImportInfo {
    name: string;
    modulePath: string;
    isExported: boolean;
    isNode: boolean;
}
export declare type ContribTypeRef = {
    kind: 'ref';
    name: string;
};
export declare type ContribTypeLiteral = {
    kind: 'literal';
    value: string;
};
export declare type ContribType = ContribTypeRef | ContribTypeLiteral;
export interface ExtractedContextTypes {
    typeImports: TypeImportInfo[];
    types: ContribType[];
}
/**
 * Extract types from all `addToContext` calls.
 */
export declare function extractContextTypes(program: ts.Program): Either<Exception, ExtractedContextTypes>;
export declare function unwrapMaybePromise(type: tsm.Type): tsm.Type<tsm.ts.Type>;
export declare function mergeUnionTypes(unionTypes: tsm.Type<tsm.ts.Type>[]): string;
export {};
//# sourceMappingURL=extractor.d.ts.map